/**
 * Railwat Station
 *
 * author: unknown
 *
 */

#define MaxWeight 128
#define Size 16

chan train = [Size] of { short };
chan truck = [Size] of { short };
chan van = [Size] of { short };

proctype split()
{
  short cargo;
  do
    :: train?cargo ->
      if
        :: (cargo >= MaxWeight) ->
          truck!cargo
        :: (cargo < MaxWeight) ->
          van!cargo
      fi;
  od
}

proctype merge()
{
  short cargo;
  do
    ::
      if
        :: truck?cargo
        :: van?cargo
      fi;
      train!cargo;
  od
}

init
{
  train!345; train!12; train!6777;
  train!32; train!0;
  run split();
  run merge()
}
